diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/adeos.c linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/adeos.c
--- linuxppc-2.6.10rc3/arch/ppc/kernel/adeos.c	1970-01-01 01:00:00.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/adeos.c	2005-01-18 23:15:23.000000000 +0100
@@ -0,0 +1,662 @@
+/*
+ *   linux/arch/ppc/kernel/adeos.c
+ *
+ *   Copyright (C) 2004 Philippe Gerum.
+ *
+ *   Adeos/PPC port over 2.6 based on the previous 2.4 implementation by:
+ *
+ *   Copyright (C) 2004 Wolfgang Grandegger.
+ *
+ *   It follows closely the ARM and x86 ports of ADEOS.
+ *
+ *   Copyright (C) 2003 Philippe Gerum.
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, Inc., 675 Mass Ave, Cambridge MA 02139,
+ *   USA; either version 2 of the License, or (at your option) any later
+ *   version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ *
+ *   Architecture-dependent ADEOS core support for PowerPC
+ */
+
+#include <linux/config.h>
+#include <linux/kernel.h>
+#include <linux/smp.h>
+#include <linux/sched.h>
+#include <linux/slab.h>
+#include <linux/bitops.h>
+#include <linux/interrupt.h>
+#include <linux/irq.h>
+#include <linux/module.h>
+#include <asm/system.h>
+#include <asm/atomic.h>
+#include <asm/hw_irq.h>
+#include <asm/irq.h>
+#include <asm/io.h>
+#include <asm/time.h>
+
+#ifdef CONFIG_SMP
+
+static cpumask_t __adeos_cpu_sync_map;
+
+static cpumask_t __adeos_cpu_lock_map;
+
+static spinlock_t __adeos_cpu_barrier = SPIN_LOCK_UNLOCKED;
+
+static atomic_t __adeos_critical_count = ATOMIC_INIT(0);
+
+static void (*__adeos_cpu_sync)(void);
+
+#endif /* CONFIG_SMP */
+
+int do_IRQ(struct pt_regs *regs);
+
+extern struct list_head __adeos_pipeline;
+
+struct pt_regs __adeos_irq_regs;
+
+/* Current reload value for the decrementer. */
+unsigned long __adeos_decr_ticks;
+
+/* Next tick date (timebase value). */
+unsigned long long __adeos_decr_next[ADEOS_NR_CPUS];
+
+static inline unsigned long ffnz (unsigned long ul) {
+
+    __asm__ __volatile__ ("cntlzw %0, %1" : "=r" (ul) : "r" (ul & (-ul)));
+    return 31 - ul;
+}
+
+#ifdef CONFIG_SMP
+
+/* Always called with hw interrupts off. */
+
+static void __adeos_do_critical_sync (unsigned irq)
+
+{
+    adeos_declare_cpuid;
+
+    adeos_load_cpuid();
+
+    cpu_set(cpuid,__adeos_cpu_sync_map);
+
+    /* Now we are in sync with the lock requestor running on another
+       CPU. Enter a spinning wait until he releases the global
+       lock. */
+    adeos_spin_lock(&__adeos_cpu_barrier);
+
+    /* Got it. Now get out. */
+
+    if (__adeos_cpu_sync)
+	/* Call the sync routine if any. */
+	__adeos_cpu_sync();
+
+    adeos_spin_unlock(&__adeos_cpu_barrier);
+
+    cpu_clear(cpuid,__adeos_cpu_sync_map);
+}
+
+#endif /* CONFIG_SMP */
+
+/* adeos_critical_enter() -- Grab the superlock for entering a global
+   critical section. On this uniprocessor-only arch, this is identical
+   to hw cli(). */
+
+unsigned long adeos_critical_enter (void (*syncfn)(void))
+
+{
+    unsigned long flags;
+
+    adeos_hw_local_irq_save(flags);
+
+#ifdef CONFIG_SMP
+    if (num_online_cpus() > 1) /* We might be running a SMP-kernel on a UP box... */
+	{
+	adeos_declare_cpuid;
+	cpumask_t lock_map;
+
+	adeos_load_cpuid();
+
+	if (!cpu_test_and_set(cpuid,__adeos_cpu_lock_map))
+	    {
+	    while (cpu_test_and_set(BITS_PER_LONG - 1,__adeos_cpu_lock_map))
+		{
+		/* Refer to the explanations found in
+		   linux/arch/asm-i386/irq.c about
+		   SUSPECTED_CPU_OR_CHIPSET_BUG_WORKAROUND for more about
+		   this strange loop. */
+		int n = 0;
+		do { cpu_relax(); } while (++n < cpuid);
+		}
+
+	    adeos_spin_lock(&__adeos_cpu_barrier);
+
+	    __adeos_cpu_sync = syncfn;
+
+	    /* Send the sync IPI to all processors but the current one. */
+	    __adeos_send_IPI_allbutself(ADEOS_CRITICAL_VECTOR);
+
+	    cpus_andnot(lock_map,cpu_online_map,__adeos_cpu_lock_map);
+
+	    while (!cpus_equal(__adeos_cpu_sync_map,lock_map))
+		cpu_relax();
+	    }
+
+	atomic_inc(&__adeos_critical_count);
+	}
+#endif /* CONFIG_SMP */
+
+    return flags;
+}
+
+/* adeos_critical_exit() -- Release the superlock. */
+
+void adeos_critical_exit (unsigned long flags)
+
+{
+#ifdef CONFIG_SMP
+    if (num_online_cpus() > 1) /* We might be running a SMP-kernel on a UP box... */
+	{
+	adeos_declare_cpuid;
+
+	adeos_load_cpuid();
+
+	if (atomic_dec_and_test(&__adeos_critical_count))
+	    {
+	    adeos_spin_unlock(&__adeos_cpu_barrier);
+
+	    while (!cpus_empty(__adeos_cpu_sync_map))
+		cpu_relax();
+
+	    cpu_clear(cpuid,__adeos_cpu_lock_map);
+	    cpu_clear(BITS_PER_LONG - 1,__adeos_cpu_lock_map);
+	    }
+	}
+#endif /* CONFIG_SMP */
+
+    adeos_hw_local_irq_restore(flags);
+}
+
+void __adeos_init_platform (void)
+
+{
+    unsigned timer_virq;
+
+    /* Allocate a virtual IRQ for the decrementer trap early to get it
+       mapped to IPIPE_VIRQ_BASE */
+
+    timer_virq = adeos_alloc_irq();
+
+    if (timer_virq != ADEOS_TIMER_VIRQ)
+	panic("Adeos: cannot reserve timer virq #%d (got #%d)",
+	      ADEOS_TIMER_VIRQ,
+	      timer_virq);
+
+    __adeos_decr_ticks = tb_ticks_per_jiffy;
+}
+
+void __adeos_init_stage (adomain_t *adp)
+
+{
+    int cpuid, n;
+
+    for (cpuid = 0; cpuid < ADEOS_NR_CPUS; cpuid++)
+	{
+	adp->cpudata[cpuid].irq_pending_hi = 0;
+
+	for (n = 0; n < IPIPE_IRQ_IWORDS; n++)
+	    adp->cpudata[cpuid].irq_pending_lo[n] = 0;
+
+	for (n = 0; n < IPIPE_NR_IRQS; n++)
+	    adp->cpudata[cpuid].irq_hits[n] = 0;
+	}
+
+    for (n = 0; n < IPIPE_NR_IRQS; n++)
+	{
+	adp->irqs[n].acknowledge = NULL;
+	adp->irqs[n].handler = NULL;
+	adp->irqs[n].control = IPIPE_PASS_MASK;	/* Pass but don't handle */
+	}
+
+#ifdef CONFIG_SMP
+    adp->irqs[ADEOS_CRITICAL_IPI].acknowledge = &__adeos_ack_irq;
+    adp->irqs[ADEOS_CRITICAL_IPI].handler = &__adeos_do_critical_sync;
+    /* Immediately handle in the current domain but *never* pass */
+    adp->irqs[ADEOS_CRITICAL_IPI].control = IPIPE_HANDLE_MASK|IPIPE_STICKY_MASK|IPIPE_SYSTEM_MASK;
+#endif /* CONFIG_SMP */
+}
+
+/* __adeos_sync_stage() -- Flush the pending IRQs for the current
+   domain (and processor).  This routine flushes the interrupt log
+   (see "Optimistic interrupt protection" from D. Stodolsky et al. for
+   more on the deferred interrupt scheme). Every interrupt that
+   occurred while the pipeline was stalled gets played.  WARNING:
+   callers on SMP boxen should always check for CPU migration on
+   return of this routine. One can control the kind of interrupts
+   which are going to be sync'ed using the syncmask
+   parameter. IPIPE_IRQMASK_ANY plays them all, IPIPE_IRQMASK_VIRT
+   plays virtual interrupts only. This routine must be called with hw
+   interrupts off. */
+
+void __adeos_sync_stage (unsigned long syncmask)
+
+{
+    unsigned long mask, submask;
+    struct adcpudata *cpudata;
+    adeos_declare_cpuid;
+    int level, rank;
+    adomain_t *adp;
+    unsigned irq;
+
+    adeos_load_cpuid();
+    adp = adp_cpu_current[cpuid];
+    cpudata = &adp->cpudata[cpuid];
+
+    do
+	{
+	/* The policy here is to keep the dispatching code
+	   interrupt-free by stalling the current stage. If the upper
+	   domain handler (which we call) wants to re-enable
+	   interrupts while in a safe portion of the code
+	   (e.g. SA_INTERRUPT flag unset for Linux's sigaction()), it
+	   will have to unstall (then stall again before returning to
+	   us!) the stage when it sees fit. */
+
+	while ((mask = (cpudata->irq_pending_hi & syncmask)) != 0)
+	    {
+	    /* Give a slight priority advantage to high-numbered IRQs
+	       like the virtual ones. */
+	    level = ffnz(mask);
+	    __clear_bit(level,&cpudata->irq_pending_hi);
+
+	    while ((submask = cpudata->irq_pending_lo[level]) != 0)
+		{
+		rank = ffnz(submask);
+		irq = (level << IPIPE_IRQ_ISHIFT) + rank;
+
+		if (test_bit(IPIPE_LOCK_FLAG,&adp->irqs[irq].control))
+		    {
+		    __clear_bit(rank,&cpudata->irq_pending_lo[level]);
+		    continue;
+		    }
+
+		if (--cpudata->irq_hits[irq] == 0)
+		    __clear_bit(rank,&cpudata->irq_pending_lo[level]);
+
+		/* Allow the sync routine to be reentered on behalf of
+		   the IRQ handler and any execution context switched
+		   in by the IRQ handler. The latter also means that
+		   returning from the switched out context is always
+		   safe even if the sync routine has been reentered in
+		   the meantime. */
+
+		__set_bit(IPIPE_STALL_FLAG,&cpudata->status);
+
+#ifdef CONFIG_ADEOS_PROFILING
+		__adeos_profile_data[cpuid].irqs[irq].n_synced++;
+		adeos_hw_tsc(__adeos_profile_data[cpuid].irqs[irq].t_synced);
+#endif /* CONFIG_ADEOS_PROFILING */
+
+		/* __adeos_irq_regs is only overwritten when a timer
+		   IRQ is caught. */
+
+		if (adp == adp_root && !adeos_virtual_irq_p(irq))
+		    adeos_hw_sti();
+
+		((void (*)(unsigned, struct pt_regs *))adp->irqs[irq].handler)(irq,&__adeos_irq_regs);
+
+		adeos_hw_cli();
+
+#ifdef CONFIG_SMP
+		adeos_load_cpuid();
+		cpudata = &adp->cpudata[cpuid];
+#endif /* CONFIG_SMP */
+
+		__clear_bit(IPIPE_STALL_FLAG,&cpudata->status);
+		}
+	    }
+	}
+    while ((cpudata->irq_pending_hi & syncmask) != 0);
+}
+
+int __adeos_ack_irq (unsigned irq)
+
+{
+    irq_desc_t *desc = irq_desc + irq;
+
+    if (desc->handler->ack != NULL)
+	{
+	unsigned long adflags;
+	adeos_declare_cpuid;
+
+	/* No need to mask IRQs at hw level: we are always called from
+	   __adeos_handle_irq(), so interrupts are already off. We
+	   stall the pipeline so that spin_lock_irq*() ops won't
+	   unintentionally flush it, since this could cause infinite
+	   recursion. */
+
+	adeos_load_cpuid();
+	adflags = adeos_test_and_stall_pipeline();
+#ifdef CONFIG_PREEMPT
+	preempt_disable();
+#endif /* CONFIG_PREEMPT */
+	spin_lock(&desc->lock);
+	desc->handler->ack(irq);
+	spin_unlock(&desc->lock);
+#ifdef CONFIG_PREEMPT
+	preempt_enable_no_resched();
+#endif /* CONFIG_PREEMPT */
+	adeos_restore_pipeline_nosync(adp_cpu_current[cpuid],adflags,cpuid);
+	}
+
+    return 1;
+}
+
+static inline void __adeos_walk_pipeline (struct list_head *pos, int cpuid)
+
+{
+    adomain_t *this_domain = adp_cpu_current[cpuid];
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *next_domain = list_entry(pos,adomain_t,p_link);
+
+	if (test_bit(IPIPE_STALL_FLAG,&next_domain->cpudata[cpuid].status))
+	    break; /* Stalled stage -- do not go further. */
+
+	if (next_domain->cpudata[cpuid].irq_pending_hi != 0)
+	    {
+	    /* Since the critical IPI might be dispatched by the
+	       following actions, the current domain might not be
+	       linked to the pipeline anymore after its handler
+	       returns on SMP boxes, even if the domain remains valid
+	       (see adeos_unregister_domain()), so don't make any
+	       dangerous assumptions here. */
+
+	    if (next_domain == this_domain)
+		__adeos_sync_stage(IPIPE_IRQMASK_ANY);
+	    else
+		{
+		__adeos_switch_to(this_domain,next_domain,cpuid);
+
+		adeos_load_cpuid(); /* Processor might have changed. */
+
+		if (!test_bit(IPIPE_STALL_FLAG,&this_domain->cpudata[cpuid].status) &&
+		    this_domain->cpudata[cpuid].irq_pending_hi != 0)
+		    __adeos_sync_stage(IPIPE_IRQMASK_ANY);
+		}
+
+	    break;
+	    }
+	else if (next_domain == this_domain)
+	    break;
+
+	pos = next_domain->p_link.next;
+	}
+}
+
+/* __adeos_handle_irq() -- ADEOS's generic IRQ handler. An optimistic
+   interrupt protection log is maintained here for each
+   domain. Interrupts are off on entry. */
+
+void __adeos_handle_irq (int irq, struct pt_regs *regs)
+
+{
+    struct list_head *head, *pos;
+    adeos_declare_cpuid;
+    int m_ack, s_ack;
+
+    m_ack = irq & ADEOS_IRQ_ACKED;
+    irq &= ADEOS_IRQ_ACKED_MASK;
+
+    if (irq >= IPIPE_NR_IRQS)
+	{
+	printk(KERN_ERR "Adeos: spurious interrupt %d\n",irq);
+	return;
+	}
+
+    adeos_load_cpuid();
+
+#ifdef CONFIG_ADEOS_PROFILING
+    __adeos_profile_data[cpuid].irqs[irq].n_handled++;
+    adeos_hw_tsc(__adeos_profile_data[cpuid].irqs[irq].t_handled);
+#endif /* CONFIG_ADEOS_PROFILING */
+
+    s_ack = m_ack;
+
+    if (test_bit(IPIPE_STICKY_FLAG,&adp_cpu_current[cpuid]->irqs[irq].control))
+	head = &adp_cpu_current[cpuid]->p_link;
+    else
+	head = __adeos_pipeline.next;
+
+    /* Ack the interrupt. */
+
+    pos = head;
+
+    while (pos != &__adeos_pipeline)
+	{
+    	adomain_t *_adp = list_entry(pos,adomain_t,p_link);
+
+	/* For each domain handling the incoming IRQ, mark it as
+           pending in its log. */
+
+	if (test_bit(IPIPE_HANDLE_FLAG,&_adp->irqs[irq].control))
+	    {
+	    /* Domains that handle this IRQ are polled for
+	       acknowledging it by decreasing priority order. The
+	       interrupt must be made pending _first_ in the domain's
+	       status flags before the PIC is unlocked. */
+
+	    _adp->cpudata[cpuid].irq_hits[irq]++;
+	    __adeos_set_irq_bit(_adp,cpuid,irq);
+
+	    /* Always get the first master acknowledge available. Once
+	       we've got it, allow slave acknowledge handlers to run
+	       (until one of them stops us). */
+
+	    if (_adp->irqs[irq].acknowledge != NULL)
+		{
+		if (!m_ack)
+		    m_ack = _adp->irqs[irq].acknowledge(irq);
+		else if (test_bit(IPIPE_SHARED_FLAG,&_adp->irqs[irq].control) && !s_ack)
+		    s_ack = _adp->irqs[irq].acknowledge(irq);
+		}
+	    }
+
+	/* If the domain does not want the IRQ to be passed down the
+	   interrupt pipe, exit the loop now. */
+
+	if (!test_bit(IPIPE_PASS_FLAG,&_adp->irqs[irq].control))
+	    break;
+
+	pos = _adp->p_link.next;
+	}
+
+    /* Now walk the pipeline, yielding control to the highest priority
+       domain that has pending interrupt(s) or immediately to the
+       current domain if the interrupt has been marked as
+       'sticky'. This search does not go beyond the current domain in
+       the pipeline. To understand this code properly, one must keep
+       in mind that domains having a higher priority than the current
+       one are sleeping on the adeos_suspend_domain() service. In
+       addition, domains having a lower priority have been preempted
+       by an interrupt dispatched to a more prioritary domain. Once
+       the first and most prioritary stage has been selected here, the
+       subsequent stages will be activated in turn when each visited
+       domain calls adeos_suspend_domain() to wake up its neighbour
+       down the pipeline. */
+
+    __adeos_walk_pipeline(head,cpuid);
+}
+
+/* ADEOS's version of the interrupt trap handler. */
+
+asmlinkage int __adeos_grab_irq (struct pt_regs *regs)
+
+{
+    extern int ppc_spurious_interrupts;
+    adeos_declare_cpuid;
+    int irq, first = 1;
+
+    if (!adp_pipelined)
+	{
+	do_IRQ(regs);
+	return 1;
+	}
+
+    if ((irq = ppc_md.get_irq(regs)) >= 0)
+	{
+	__adeos_handle_irq(irq,regs);
+	first = 0;
+	}
+    else if (irq != -2 && first)
+	     ppc_spurious_interrupts++;
+
+    adeos_load_cpuid();
+
+    return (adp_cpu_current[cpuid] == adp_root &&
+	    !test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status));
+}
+
+/* ADEOS's version of irq.c:do_IRQ(). */
+
+void __adeos_do_IRQ (int irq, struct pt_regs *regs)
+
+{
+    irq_enter();
+    __do_IRQ(irq,regs);
+    irq_exit();
+}
+
+/* ADEOS's version of the decrementer trap handler. */
+
+asmlinkage int __adeos_grab_timer (struct pt_regs *regs)
+
+{
+    adeos_declare_cpuid;
+
+    if (!adp_pipelined)
+	{
+	timer_interrupt(regs);
+	return 1;
+	}
+
+    __adeos_irq_regs.msr = regs->msr; /* for do_timer() */
+
+    __adeos_handle_irq(ADEOS_TIMER_VIRQ,regs);
+
+    adeos_load_cpuid();
+
+#ifndef CONFIG_40x
+    if (__adeos_decr_ticks != tb_ticks_per_jiffy)
+	{
+	unsigned long long next_date, now;
+
+	next_date = __adeos_decr_next[cpuid];
+
+	while ((now = __adeos_read_timebase()) >= next_date)
+	    next_date += __adeos_decr_ticks;
+
+	set_dec(next_date - now);
+
+	__adeos_decr_next[cpuid] = next_date;
+	}
+#endif /* !CONFIG_40x */
+
+    return (adp_cpu_current[cpuid] == adp_root &&
+	    !test_bit(IPIPE_STALL_FLAG,&adp_root->cpudata[cpuid].status));
+}
+
+void __adeos_do_timer (int irq, struct pt_regs *regs)
+
+{
+    timer_interrupt(regs);
+}
+
+asmlinkage int __adeos_check_root (struct pt_regs *regs)
+
+{
+    adeos_declare_cpuid;
+    /* This routine is called with hw interrupts off, so no migration
+       can occur while checking the identity of the current domain. */
+    adeos_load_cpuid();
+    return adp_cpu_current[cpuid] == adp_root;
+}
+
+/* adeos_trigger_irq() -- Push the interrupt to the pipeline entry
+   just like if it has been actually received from a hw source. This
+   both works for real and virtual interrupts. This also means that
+   the current domain might be immediately preempted by a more
+   prioritary domain who happens to handle this interrupt. */
+
+int adeos_trigger_irq (unsigned irq)
+
+{
+    struct pt_regs regs;
+    unsigned long flags;
+
+    if (irq >= IPIPE_NR_IRQS ||
+	(adeos_virtual_irq_p(irq) && !test_bit(irq - IPIPE_VIRQ_BASE,&__adeos_virtual_irq_map)))
+	return -EINVAL;
+
+    adeos_hw_local_irq_save(flags);
+
+    regs.msr = flags;
+
+    __adeos_handle_irq(irq | ADEOS_IRQ_ACKED, &regs);
+
+    adeos_hw_local_irq_restore(flags);
+
+    return 1;
+}
+
+int __adeos_enter_syscall (struct pt_regs *regs)
+
+{
+    /* By convention, this routine should either return:
+       0 -- if the syscall is to be passed to Linux;
+       1 -- if the syscall should not be passed to Linux, and no
+       tail work should be performed;
+       -1 -- if the syscall should not be passed to Linux but the
+       tail work has to be performed. */
+
+    if (__adeos_event_monitors[ADEOS_SYSCALL_PROLOGUE] > 0 &&
+	__adeos_handle_event(ADEOS_SYSCALL_PROLOGUE,regs) > 0)
+	return adp_current == adp_root && !in_atomic() ? -1 : 1;
+
+    return 0;
+}
+
+int __adeos_exit_syscall (void) 
+
+{
+    if (__adeos_event_monitors[ADEOS_SYSCALL_EPILOGUE] > 0)
+	return __adeos_handle_event(ADEOS_SYSCALL_EPILOGUE,NULL);
+
+    return 0;
+}
+
+EXPORT_SYMBOL(__adeos_init_stage);
+EXPORT_SYMBOL(__adeos_sync_stage);
+EXPORT_SYMBOL(__adeos_irq_regs);
+#ifdef CONFIG_ADEOS_THREADS
+EXPORT_SYMBOL(__adeos_switch_domain);
+#endif /* CONFIG_ADEOS_THREADS */
+EXPORT_SYMBOL(__adeos_do_IRQ);
+EXPORT_SYMBOL(__adeos_do_timer);
+EXPORT_SYMBOL(__adeos_decr_ticks);
+EXPORT_SYMBOL(__adeos_decr_next);
+EXPORT_SYMBOL(__adeos_current_threadinfo);
+EXPORT_SYMBOL(adeos_critical_enter);
+EXPORT_SYMBOL(adeos_critical_exit);
+EXPORT_SYMBOL(adeos_trigger_irq);
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/entry.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/entry.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/entry.S	2004-12-06 17:17:20.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/entry.S	2005-02-14 11:44:01.000000000 +0100
@@ -143,8 +143,23 @@ END_FTR_SECTION_IFSET(CPU_FTR_CAN_NAP)
 	.globl transfer_to_handler_cont
 transfer_to_handler_cont:
 	lwz	r11,THREAD_INFO-THREAD(r12)
+#ifdef CONFIG_ADEOS_CORE
+	/* Allow for kernel-based local stacks: those must not cause
+	the stack overflow detection to trigger when some activity has
+	been preempted over them (e.g. Adeos domain stacks). We just
+	check if the kernel stack is not treading on the memory area
+	ranging from &current->thread_info to &current->thread, which
+	is coarser than the vanilla implementation, but likely
+	sensitive enough to catch overflows soon enough though.*/
+	addi	r9,r11,THREAD
+	cmplw	0,r1,r11
+	cmplw	1,r1,r9
+	crand	1,1,4
+	bgt-	stack_ovf		/* if r11 < r1 < r11+THREAD */
+#else /* CONFIG_ADEOS_CORE */
 	cmplw	r1,r11			/* if r1 <= current->thread_info */
 	ble-	stack_ovf		/* then the kernel stack overflowed */
+#endif /* CONFIG_ADEOS_CORE */
 3:
 	mflr	r9
 	lwz	r11,0(r9)		/* virtual address of handler */
@@ -195,6 +210,21 @@ _GLOBAL(DoSyscall)
 	lwz	r11,_CCR(r1)	/* Clear SO bit in CR */
 	rlwinm	r11,r11,0,4,2
 	stw	r11,_CCR(r1)
+#ifdef CONFIG_ADEOS_CORE
+	addi	r3,r1,GPR0
+	bl	__adeos_enter_syscall
+	cmpwi	r3,0
+	lwz	r3,GPR3(r1)
+	bgt	.adeos_end_syscall
+	blt	ret_from_syscall
+	lwz	r0,GPR0(r1)
+	lwz	r4,GPR4(r1)
+	lwz	r5,GPR5(r1)
+	lwz	r6,GPR6(r1)
+	lwz	r7,GPR7(r1)
+	lwz	r8,GPR8(r1)
+	lwz	r9,GPR9(r1)
+#endif /* CONFIG_ADEOS_CORE */
 #ifdef SHOW_SYSCALLS
 	bl	do_show_syscall
 #endif /* SHOW_SYSCALLS */
@@ -215,6 +245,13 @@ syscall_dotrace_cont:
 	mtlr	r10
 	addi	r9,r1,STACK_FRAME_OVERHEAD
 	blrl			/* Call handler */
+#ifdef CONFIG_ADEOS_CORE
+	stw	r3,RESULT(r1)	/* Save result */
+	bl	__adeos_exit_syscall
+	cmpwi	r3,0
+	lwz	r3,RESULT(r1)
+	bne-	syscall_exit_cont
+#endif /* CONFIG_ADEOS_CORE */
 	.globl	ret_from_syscall
 ret_from_syscall:
 #ifdef SHOW_SYSCALLS
@@ -262,6 +299,14 @@ syscall_exit_cont:
 	SYNC
 	RFI
 
+#ifdef CONFIG_ADEOS_CORE
+.adeos_end_syscall:
+	LOAD_MSR_KERNEL(r10,MSR_KERNEL)	/* doesn't include MSR_EE */
+	SYNC
+	MTMSRD(r10)
+	b syscall_exit_cont
+#endif /* CONFIG_ADEOS_CORE */
+
 66:	li	r3,-ENOSYS
 	b	ret_from_syscall
 
@@ -586,6 +631,12 @@ ret_from_except:
 	SYNC			/* Some chip revs have problems here... */
 	MTMSRD(r10)		/* disable interrupts */
 
+#ifdef CONFIG_ADEOS_CORE
+        bl __adeos_check_root
+        cmpwi   r3, 0
+        beq- restore
+#endif /* CONFIG_ADEOS_CORE */
+
 	lwz	r3,_MSR(r1)	/* Returning to user mode? */
 	andi.	r0,r3,MSR_PR
 	beq	resume_kernel
@@ -1024,3 +1075,119 @@ machine_check_in_rtas:
 	/* XXX load up BATs and panic */
 
 #endif /* CONFIG_PPC_OF */
+
+#ifdef CONFIG_ADEOS_CORE
+
+_GLOBAL(__adeos_ret_from_except)
+        cmpwi   r3, 0
+        bne+ ret_from_except
+        b restore
+
+#ifdef CONFIG_ADEOS_THREADS
+
+/*
+ * r3 = adp_next, r4 = adp_cpu_current[adeos_processor_id()].
+ * NOTE: This code is _not_ SMP-compliant. Always called with hw
+ * interrupts off.
+ */
+_GLOBAL(__adeos_switch_domain)
+
+	stwu	r1,-108-STACK_FRAME_OVERHEAD(r1)
+
+	/* Save general purpose registers. */
+	stw	r31,STACK_FRAME_OVERHEAD+0*4(r1)
+	stw	r30,STACK_FRAME_OVERHEAD+1*4(r1)
+	stw	r29,STACK_FRAME_OVERHEAD+2*4(r1)
+	stw	r28,STACK_FRAME_OVERHEAD+3*4(r1)
+	stw	r27,STACK_FRAME_OVERHEAD+4*4(r1)
+	stw	r26,STACK_FRAME_OVERHEAD+5*4(r1)
+	stw	r25,STACK_FRAME_OVERHEAD+6*4(r1)
+	stw	r24,STACK_FRAME_OVERHEAD+7*4(r1)
+	stw	r23,STACK_FRAME_OVERHEAD+8*4(r1)
+	stw	r22,STACK_FRAME_OVERHEAD+9*4(r1)
+	stw	r21,STACK_FRAME_OVERHEAD+10*4(r1)
+	stw	r20,STACK_FRAME_OVERHEAD+11*4(r1)
+	stw	r19,STACK_FRAME_OVERHEAD+12*4(r1)
+	stw	r18,STACK_FRAME_OVERHEAD+13*4(r1)
+	stw	r17,STACK_FRAME_OVERHEAD+14*4(r1)
+	stw	r16,STACK_FRAME_OVERHEAD+15*4(r1)
+	stw	r15,STACK_FRAME_OVERHEAD+16*4(r1)
+	stw	r14,STACK_FRAME_OVERHEAD+17*4(r1)
+	stw	r13,STACK_FRAME_OVERHEAD+18*4(r1)
+	stw	 r3,STACK_FRAME_OVERHEAD+19*4(r1)
+	stw	 r2,STACK_FRAME_OVERHEAD+20*4(r1)
+	stw	 r0,STACK_FRAME_OVERHEAD+21*4(r1)
+
+	/* Save special registers. */
+	mfctr	 r2
+	stw	 r2,STACK_FRAME_OVERHEAD+22*4(r1)
+	mfcr	 r2
+	stw	 r2,STACK_FRAME_OVERHEAD+23*4(r1)
+	mfxer	 r2
+	stw	 r2,STACK_FRAME_OVERHEAD+24*4(r1)
+	mflr	 r2
+	stw	 r2,STACK_FRAME_OVERHEAD+25*4(r1)
+	mfmsr	 r2
+	stw	 r2,STACK_FRAME_OVERHEAD+26*4(r1)
+
+	/* Actual switch block. */
+	lwz	 r2,0(r4)	/* r2 = old_adp = adp_cpu_current[cpuid] */
+	stw	 r1,0(r2)	/* old_adp->esp[0] = sp */
+	stw	 r3,0(r4)	/* adp_cpu_current[cpuid] = new_adp */
+	/* CONFIG_SMP should sync here; but first, accesses to esp[]
+	would require cpuid-indexing. */
+	lwz	 r1,0(r3)	/* sp = new_adp->esp[0] */
+
+	/* Restore special registers. */
+	lwz	 r2,STACK_FRAME_OVERHEAD+26*4(r1)
+	mtmsr	 r2
+	lwz	 r2,STACK_FRAME_OVERHEAD+25*4(r1)
+	mtlr	 r2
+	lwz	 r2,STACK_FRAME_OVERHEAD+24*4(r1)
+	mtxer	 r2
+	lwz	 r2,STACK_FRAME_OVERHEAD+23*4(r1)
+	mtcr	 r2
+	lwz	 r2,STACK_FRAME_OVERHEAD+22*4(r1)
+	mtctr	 r2
+
+	/* Restore general purpose registers. */
+	lwz	 r0,STACK_FRAME_OVERHEAD+21*4(r1)
+	lwz	 r2,STACK_FRAME_OVERHEAD+20*4(r1)
+	lwz	 r3,STACK_FRAME_OVERHEAD+19*4(r1)
+	lwz	r13,STACK_FRAME_OVERHEAD+18*4(r1)
+	lwz	r14,STACK_FRAME_OVERHEAD+17*4(r1)
+	lwz	r15,STACK_FRAME_OVERHEAD+16*4(r1)
+	lwz	r16,STACK_FRAME_OVERHEAD+15*4(r1)
+	lwz	r17,STACK_FRAME_OVERHEAD+14*4(r1)
+	lwz	r18,STACK_FRAME_OVERHEAD+13*4(r1)
+	lwz	r19,STACK_FRAME_OVERHEAD+12*4(r1)
+	lwz	r20,STACK_FRAME_OVERHEAD+11*4(r1)
+	lwz	r21,STACK_FRAME_OVERHEAD+10*4(r1)
+	lwz	r22,STACK_FRAME_OVERHEAD+9*4(r1)
+	lwz	r23,STACK_FRAME_OVERHEAD+8*4(r1)
+	lwz	r24,STACK_FRAME_OVERHEAD+7*4(r1)
+	lwz	r25,STACK_FRAME_OVERHEAD+6*4(r1)
+	lwz	r26,STACK_FRAME_OVERHEAD+5*4(r1)
+	lwz	r27,STACK_FRAME_OVERHEAD+4*4(r1)
+	lwz	r28,STACK_FRAME_OVERHEAD+3*4(r1)
+	lwz	r29,STACK_FRAME_OVERHEAD+2*4(r1)
+	lwz	r30,STACK_FRAME_OVERHEAD+1*4(r1)
+	lwz	r31,STACK_FRAME_OVERHEAD+0*4(r1)
+
+	addi	r1,r1,108+STACK_FRAME_OVERHEAD
+
+	blr
+
+#endif /* CONFIG_ADEOS_THREADS */
+
+/* Returns the current threadinfo pointer in a way which is
+   insensitive to the underlying stack, by directly reading the
+   special purpose register #3. */
+	
+_GLOBAL(__adeos_current_threadinfo)
+	mfspr	r3,SPRG3
+	addi	r3,r3,-THREAD
+	tovirt(r3,r3)
+	blr
+	
+#endif /* CONFIG_ADEOS_CORE */
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head.S	2004-12-06 17:15:56.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head.S	2005-01-01 18:19:37.000000000 +0100
@@ -339,6 +339,12 @@ i##n:								\
 	EXC_XFER_TEMPLATE(n, hdlr, n+1, NOCOPY, transfer_to_handler, \
 			  ret_from_except)
 
+#ifdef CONFIG_ADEOS_CORE
+#define EXC_XFER_ADEOS_LITE(n, hdlr)		\
+	EXC_XFER_TEMPLATE(n, hdlr, n+1, NOCOPY, transfer_to_handler, \
+			  __adeos_ret_from_except)
+#endif /* CONFIG_ADEOS_CORE */
+
 #define EXC_XFER_EE(n, hdlr)		\
 	EXC_XFER_TEMPLATE(n, hdlr, n, COPY_EE, transfer_to_handler_full, \
 			  ret_from_except_full)
@@ -445,7 +451,11 @@ InstructionAccess:
 #endif /* CONFIG_PPC64BRIDGE */
 
 /* External interrupt */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x500, HardwareInterrupt, __adeos_grab_irq, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x500, HardwareInterrupt, do_IRQ, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 /* Alignment exception */
 	. = 0x600
@@ -470,7 +480,11 @@ FPUnavailable:
 	EXC_XFER_EE_LITE(0x800, KernelFP)
 
 /* Decrementer */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x900, Decrementer, __adeos_grab_timer, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x900, Decrementer, timer_interrupt, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 	EXCEPTION(0xa00, Trap_0a, UnknownException, EXC_XFER_EE)
 	EXCEPTION(0xb00, Trap_0b, UnknownException, EXC_XFER_EE)
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head_44x.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_44x.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head_44x.S	2004-12-06 17:15:16.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_44x.S	2005-01-01 18:19:37.000000000 +0100
@@ -421,7 +421,11 @@ interrupt_base:
 	EXC_XFER_EE_LITE(0x0400, handle_page_fault)
 
 	/* External Input Interrupt */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x0500, ExternalInput, __adeos_grab_irq, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x0500, ExternalInput, do_IRQ, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 	/* Alignment Interrupt */
 	START_EXCEPTION(Alignment)
@@ -456,7 +460,11 @@ interrupt_base:
 	lis     r0,TSR_DIS@h            /* Setup the DEC interrupt mask */
 	mtspr   SPRN_TSR,r0		/* Clear the DEC interrupt */
 	addi    r3,r1,STACK_FRAME_OVERHEAD
+#ifdef CONFIG_ADEOS_CORE
+	EXC_XFER_ADEOS_LITE(0x1000, __adeos_grab_timer)
+#else /* !CONFIG_ADEOS_CORE */
 	EXC_XFER_LITE(0x1000, timer_interrupt)
+#endif /* CONFIG_ADEOS_CORE */
 
 	/* Fixed Internal Timer Interrupt */
 	/* TODO: Add FIT support */
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head_4xx.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_4xx.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head_4xx.S	2004-12-06 17:17:54.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_4xx.S	2005-01-01 18:19:37.000000000 +0100
@@ -272,7 +272,13 @@ label:
 	EXC_XFER_TEMPLATE(hdlr, n+1, MSR_KERNEL, NOCOPY, transfer_to_handler, \
 			  ret_from_except)
 
-#define EXC_XFER_EE(n, hdlr)		\
+#ifdef CONFIG_ADEOS_CORE
+#define EXC_XFER_ADEOS_LITE(n, hdlr)		\
+	EXC_XFER_TEMPLATE(hdlr, n+1, MSR_KERNEL, NOCOPY, transfer_to_handler, \
+			  __adeos_ret_from_except)
+#endif /* CONFIG_ADEOS_CORE */
+
+	#define EXC_XFER_EE(n, hdlr)		\
 	EXC_XFER_TEMPLATE(hdlr, n, MSR_KERNEL, COPY_EE, transfer_to_handler_full, \
 			  ret_from_except_full)
 
@@ -280,7 +286,6 @@ label:
 	EXC_XFER_TEMPLATE(hdlr, n+1, MSR_KERNEL, COPY_EE, transfer_to_handler, \
 			  ret_from_except)
 
-
 /*
  * 0x0100 - Critical Interrupt Exception
  */
@@ -435,7 +440,11 @@ label:
 	EXC_XFER_EE_LITE(0x400, handle_page_fault)
 
 /* 0x0500 - External Interrupt Exception */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x0500, HardwareInterrupt, __adeos_grab_irq, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x0500, HardwareInterrupt, do_IRQ, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 /* 0x0600 - Alignment Exception */
 	START_EXCEPTION(0x0600, Alignment)
@@ -473,7 +482,11 @@ label:
 	lis	r0,TSR_PIS@h
 	mtspr	SPRN_TSR,r0		/* Clear the PIT exception */
 	addi	r3,r1,STACK_FRAME_OVERHEAD
+#ifdef CONFIG_ADEOS_CORE
+	EXC_XFER_ADEOS_LITE(0x1000, __adeos_grab_timer)
+#else /* !CONFIG_ADEOS_CORE */
 	EXC_XFER_LITE(0x1000, timer_interrupt)
+#endif /* CONFIG_ADEOS_CORE */
 
 #if 0
 /* NOTE:
diff -uNrp linuxppc-2.6.10rc3/arch/ppc/kernel/head_8xx.S linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_8xx.S
--- linuxppc-2.6.10rc3/arch/ppc/kernel/head_8xx.S	2004-12-06 17:15:50.000000000 +0100
+++ linuxppc-2.6.10rc3-adeos/arch/ppc/kernel/head_8xx.S	2005-01-01 18:19:37.000000000 +0100
@@ -194,7 +194,13 @@ i##n:								\
 	EXC_XFER_TEMPLATE(n, hdlr, n+1, NOCOPY, transfer_to_handler, \
 			  ret_from_except)
 
-#define EXC_XFER_EE(n, hdlr)		\
+#ifdef CONFIG_ADEOS_CORE
+#define EXC_XFER_ADEOS_LITE(n, hdlr)		\
+	EXC_XFER_TEMPLATE(n, hdlr, n+1, NOCOPY, transfer_to_handler, \
+			  __adeos_ret_from_except)
+#endif /* CONFIG_ADEOS_CORE */
+
+	#define EXC_XFER_EE(n, hdlr)		\
 	EXC_XFER_TEMPLATE(n, hdlr, n, COPY_EE, transfer_to_handler_full, \
 			  ret_from_except_full)
 
@@ -241,7 +247,11 @@ InstructionAccess:
 	EXC_XFER_EE_LITE(0x400, handle_page_fault)
 
 /* External interrupt */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x500, HardwareInterrupt, __adeos_grab_irq, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x500, HardwareInterrupt, do_IRQ, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 /* Alignment exception */
 	. = 0x600
@@ -262,7 +272,11 @@ Alignment:
 	EXCEPTION(0x800, FPUnavailable, UnknownException, EXC_XFER_STD)
 
 /* Decrementer */
+#ifdef CONFIG_ADEOS_CORE
+	EXCEPTION(0x900, Decrementer, __adeos_grab_timer, EXC_XFER_ADEOS_LITE)
+#else /* !CONFIG_ADEOS_CORE */
 	EXCEPTION(0x900, Decrementer, timer_interrupt, EXC_XFER_LITE)
+#endif /* CONFIG_ADEOS_CORE */
 
 	EXCEPTION(0xa00, Trap_0a, UnknownException, EXC_XFER_EE)
 	EXCEPTION(0xb00, Trap_0b, UnknownException, EXC_XFER_EE)
